#=============================================================

.AUTODEPEND

#=============================================================
#		Translator Definitions
#=============================================================
CC = bcc.exe +bcc.CFG
TASM = tasm.exe
TLIB = tlib.exe
TLINK = tlink
RC = brcc.exe
RB = rc.exe
BCPATH = \BCOS2\\
LIBPATH = $(BCPATH)LIB
INCLUDEPATH = $(BCPATH)INCLUDE;

#=============================================================
#		Implicit Rules
#=============================================================
.c.obj:
  $(CC) -c {$< }

.cpp.obj:
  $(CC) -c {$< }

.asm.obj:
  $(TASM) -Mx $*.asm,$*.obj

.rc.res:
  $(RC) -r $*.rc

#=============================================================
#		List Macros
#=============================================================


EXE_DEPENDENCIES =  \
close_test.obj

#=============================================================
#		Explicit Rules
#=============================================================
close_test.exe: bcc.cfg $(EXE_DEPENDENCIES)
  $(TLINK) /c /Toe /ap /L$(LIBPATH) @&&|
$(BCPATH)LIB\C02.OBJ+
close_test.obj
close_test,close_test
C2MT.LIB+
OS2.LIB

|


#=============================================================
#		Individual File Dependencies
#=============================================================
close_test.obj: bcc.cfg close_test.cpp

#=============================================================
#		Compiler Configuration File
#=============================================================
bcc.cfg: bcc.mak
  copy &&|
-R
-L$(LIBPATH)
-I$(INCLUDEPATH)
-DBCOS2COMPILER
-vi-
-sm
-N
-K
#-v
| bcc.cfg

