#define INCL_DOS
#define INCL_DOSSEMAPHORES
#include <os2.h>
#include <stdio.h>
#include <process.h>
#include <conio.h>
#include <errno.h>

#define beginthread_BCOS2 _beginthread( mythread, 4096, NULL )
#define beginthread_ICC _beginthread( mythread, NULL, 4096, NULL )
#define beginthread2_BCOS2 _beginthread( mythread2, 4096, NULL )
#define beginthread2_ICC _beginthread( mythread2, NULL, 4096, NULL )


unsigned doExit = 0;
unsigned TNumber = 0;
int TStart = 7;
PSZ	szSemName = "\\SEM32\\CLOSE_TEST";
HEV	hev;


#ifdef BCOS2COMPILER
void mythread( void * );
void mythread2( void * );
#endif
#ifdef ICCCOMPILER
void _Optlink mythread( void * );
void _Optlink mythread2( void * );
#endif

void main()
{

DosCreateEventSem( szSemName, &hev, DC_SEM_SHARED, FALSE);

#ifdef BCOS2COMPILER
	beginthread_BCOS2;	beginthread_BCOS2;	beginthread_BCOS2;
	beginthread_BCOS2;	beginthread_BCOS2;	beginthread_BCOS2;
	beginthread2_BCOS2;	beginthread2_BCOS2;	beginthread2_BCOS2;
	beginthread2_BCOS2;	beginthread2_BCOS2;	beginthread2_BCOS2;
#endif
#ifdef ICCCOMPILER
	beginthread_ICC;	beginthread_ICC;	beginthread_ICC;
	beginthread_ICC;	beginthread_ICC;	beginthread_ICC;
	beginthread2_ICC;	beginthread2_ICC;	beginthread2_ICC;
	beginthread2_ICC;	beginthread2_ICC;	beginthread2_ICC;
#endif
while(1) 
{
	if( kbhit() )
	{
		if(getch()==0) getch();
		doExit = 1;
		printf( "Any key pressed. Stop and exit\n" );
	}
	if( doExit ) 
	{
		DosPostEventSem( hev );
		DosSleep( 2000 );
		break;
	}
	DosSleep( 100 );
	if( TNumber > 9999000 ) doExit = 1;
	if( --TStart < 0 )
	{
		DosPostEventSem( hev );
		TStart = 7;
		ULONG rc;
		DosResetEventSem( hev, &rc );
	}
}
DosCloseEventSem( hev );
return;
}

#ifdef BCOS2COMPILER
void mythread( void * )
#endif
#ifdef ICCCOMPILER
void _Optlink mythread( void * )
#endif
{
FILE *tmp;
char buf[256];

while(1)
{
	// Make unique filename
	sprintf( buf, "$%07d.$$$", TNumber++ );
	tmp = fopen( buf, "w" );
	if( tmp == NULL ) 
	{
		printf( "Cant open file: %s\n", buf );
		continue;
	}
	fprintf( tmp, "%s\n", buf );
	DosWaitEventSem( hev, (ULONG) SEM_INDEFINITE_WAIT );
	fclose( tmp );
//	if( rc ) printf( "Error access in mydelete: %s\n", buf );
	int rc = unlink( buf );
	if( rc ) printf( "Error %d to delete: %s\n", errno, buf );
	if( doExit ) _endthread();
}
}

#ifdef BCOS2COMPILER
void mythread2( void * )
#endif
#ifdef ICCCOMPILER
void _Optlink mythread2( void * )
#endif
{
while(1)
{
	DosWaitEventSem( hev, (ULONG) SEM_INDEFINITE_WAIT );
	spawnlp(P_WAIT, "mydelete.exe", "mydelete.exe", "nothing", NULL);
	if( doExit ) _endthread();
}
}
